#!/usr/bin/env node
import { PublishModeEnum as h } from "./utils/types.mjs";
import { inc as p, prerelease as S } from "semver";
import { join as u } from "node:path";
import { execSync as o } from "node:child_process";
import f from "pinyin";
import { readFileSync as y, existsSync as d } from "node:fs";
import c from "chalk";
const w = "/.dc/publish.json", $ = "/package.json", b = ({ gitOriginName: r = "origin" }) => {
  try {
    const i = o("git rev-parse HEAD").toString().trim(), s = o('git log -1 --pretty=format:"%an"').toString().trim(), a = o('git log -1 --pretty=format:"%ae"').toString().trim(), t = o('git log -1 --pretty=format:"%s"').toString().trim(), n = o("git config user.name").toString().trim(), e = o("git config user.email").toString().trim(), g = o("git rev-parse --abbrev-ref HEAD").toString().trim();
    let l = "";
    try {
      l = o(`git config --get remote.${r}.url`).toString().trim();
    } catch {
      throw new Error(`git remote ${r} 不存在`);
    }
    return {
      lastHash: i,
      lastCommitter: s,
      lastCommitterPinYin: f(s, {
        style: f.STYLE_NORMAL,
        heteronym: !1
      }).join(""),
      lastCommitEmail: a,
      lastCommitMsg: t,
      userName: n,
      userNamePinYin: f(n, {
        style: f.STYLE_NORMAL,
        heteronym: !1
      }).join(""),
      userEmail: e,
      branchName: g,
      remoteUrl: l
    };
  } catch (i) {
    throw console.error("Error fetching git information:", i), i;
  }
}, v = async (r) => {
  const i = y(u(process.cwd(), $), "utf-8"), s = JSON.parse(i);
  let a = s.name, t = "", n;
  const { version: e } = s;
  if (["major", "minor", "patch"].includes(r))
    t = p(e, r), n = "latest";
  else if (["premajor", "preminor", "prepatch"].includes(r)) {
    const g = S(e);
    g ? (console.log(
      c.yellow("当前版本已经是预发布版本，将会在当前版本基础上进行发布")
    ), g.length === 1 && typeof g[0] == "number" ? t = p(e, "prerelease") : t = e.split("-")[0] + "-0") : t = p(e, r), n = "next";
  } else
    n = "alpha", t = p(e, "prerelease", n);
  if (!t)
    throw new Error("version is empty");
  return {
    name: a,
    version: t,
    tag: n
  };
}, N = () => {
  let r;
  const i = u(process.cwd(), w);
  if (d(i)) {
    const s = y(i, "utf-8");
    r = JSON.parse(s);
  } else
    console.log(
      c.yellow(`未找到配置文件，将使用默认配置
      { gitOriginName: "origin" }
    `)
    );
  return {
    gitOriginName: "origin",
    ...r || {}
  };
}, C = async (r) => {
  console.log(r);
  const { mode: i, type: s, push: a } = r, t = N(), n = b(t);
  console.log("type:", s), console.log("gitInfo:", n);
  const e = await v(s), { version: g } = e;
  console.log("npmInfo:", e), o(`npm version ${g} 1>&2`);
  try {
    if (i === h.NPM) {
      const { tag: l } = e;
      o(`npm publish --tag ${l} 1>&2`);
    } else if (i === h.WEB) {
      const { webBuild: l } = t;
      l ? o(`${l} 1>&2`) : console.log(c.yellow("webBuild为空，不执行web构建"));
    } else
      throw new Error("未知命令");
  } catch (l) {
    console.log(c.red(`发布失败, error: ${l.message}`));
    try {
      console.log(
        c.blue(`回滚本地版本到发布前的版本：${n.lastHash}`)
      );
      const { lastHash: m } = n;
      o(`git reset --hard ${m} 1>&2`), console.log(c.blue(`删除本次发布时生成的tag：v${e.version}`)), o(`git tag -d v${e.version} 1>&2`);
    } catch (m) {
      console.log(c.red(`回滚失败, error: ${m.message}`));
    }
    return process.exit(1);
  }
  a && (o(`git push ${t.gitOriginName} v${e.version} 1>&2`), o(`git push ${t.gitOriginName} ${n.branchName} 1>&2`)), console.log(c.green("发布成功"));
};
export {
  C as handler
};
